require "player"
require "map"
require "bullet"
require "enemy"

function love.load()
	--SPIKES
	
	F1 = 4
	
	F2 = 5
	
	F3 = 6
	
	F4 = 7
	
	F5 = 8
	
	--------------------------------
	
	--PICTURES
	
	B_pic = love.graphics.newImage("pics/bullet.png")
	
	lava = love.graphics.newImage("pics/lava.png")
	
	spike = love.graphics.newImage("pics/spike.png")
	
	E = love.graphics.newImage("pics/enemy.png")
	
	--------------------------------
	g = love.graphics
	
	startstate = "starting"
	
	maploaded = false
	
	--PLAYER/BULLET VARIABLES
	
	bulletcollided = false
	
	shootable = true
	
	onGround = false
	
	skin = skin_1
	
	P_bullets = 8
	
	P_storedY = 0
	
	P_timer = 0
	
	P_deaths = 0
	
	B_x = 0
	
	B_y = 0
	
	--------------------------------
	
	--FONTS
	
	medium = g.newFont(45)
	
	small = g.newFont(20)
	--------------------------------
	
	gamestate = "lvl 1"
	
	--gamestate = "lvl 2"
	
	--gamestate = "lvl 3"

	
	tiledivisor = 32
	
	mapload()
	
	g.setBackgroundColor(0,0,0,255)
	
	--ENEMY
	
	enemyloaded = false
	
	--------------------------------
end

function mapCollide(x,y)
	if maploaded == true then
	checkMap = map[math.floor(y/player.h) + 1][math.floor(x/player.w) + 1]
	if checkMap == 3 or
	checkMap == 4 or
	checkMap == 5 or
	checkMap == 6 or
	checkMap == 7 or
	checkMap == 8 then
	player.load()
	P_deaths = P_deaths + 1
	end
	if checkMap == 1 or checkMap == 2 then
	return true
		end
	end
end

function B_mapCollide(x,y)
	if maploaded == true then
	B_checkMap = map[math.floor(y/player.h) + 1][math.floor(x/player.w) + 1]
	if B_checkMap == F1 then
	F1 = 0
	mapload()
	end
	if B_checkMap == F2 then
	F2 = 0
	mapload()
	end
	if B_checkMap == F3 then
	F3 = 0
	mapload()
	end
	if B_checkMap == F4 then
	F4 = 0
	mapload()
	end
	if B_checkMap == F5 then
	F5 = 0
	mapload()
	end
	if B_checkMap == 1 or B_checkMap == 2 or B_checkMap == 4 or B_checkMap == 5 or B_checkMap == 6 or B_checkMap == 7 or B_checkMap == 8 then
	return true
		end
	end
end

function E_mapCollide(x,y)
	if maploaded == true then
	E_checkMap = map[math.floor(y/player.h) + 1][math.floor(x/player.w) + 1]
	if E_checkMap == E then
	return true
		end
	end
end

function love.update(dt)

	enemy_check(dt)

	enemyupdate(dt)
	
	enemycollide(dt)
	
	enemy_die(dt)
	
	bullet_update(dt)
	
	bulletremove()
	
	bulletcollide(dt)
	
	bullet_storeXY(dt)
	
	playerjump(dt)
	
	playerupdate(dt)
	
	mapEnd()
	
	playerjumpMax(dt)
	
	playerP_timer(dt)
	
end

function love.draw()

	bulletdraw()

	if startstate == "starting" then
		g.setFont(small)
		g.print("Hello! Welcome To PlatformGuy!", 266, 220)
		g.print("Controls Are: Arrow Keys,",266, 240)
		g.print("Enter To Restart LvL,",266, 260)
		g.print("Spacebar to shoot, (Try shooting Spikes!)",266,280)
		g.print("S to change Skin!",266,300)
		g.print("Press Enter To Start!",266,320)
	end
	
	enemy_draw()
	
	playerdraw()
	
	mapdraw()
	
	bullet_counter_draw()
	
	g.setFont(small)
	g.print("Deaths:" .. P_deaths, 300, 5)
	
	--DEBUGGING
	
		--print( P_storedY ,5, 65)
		--print( P_timer )
		--print( P_storedY - player.y ,5, 25)
		--print( player.x)
		--print( player.y)
		--print( B_x )
		--print( B_y )
	
	--------------------------------
	
	if gamestate == "lvl 2" then
	g.setColor(0,255,0,100)
	g.print("Congratz to Nsmurf for finding the Waffles!",40,268)
	end
end

function love.keypressed(key)
	playerstore(key)
	
	playerplace(key)
	
	skinchange(key)
	
	bulletshoot(key)
end

function love.keyreleased(key)
	playerfall()
end

function mapChange1()
	if gamestate == "lvl 1" then
	gamestate = "lvl 2"
	F1 = 4
	F2 = 5
	F3 = 6
	F4 = 7
	mapload()
	player.load()
	P_bullets = 8
	end
end

function mapChange2()
	if gamestate == "lvl 2" then
	gamestate = "lvl 3"
	F1 = 4
	F2 = 5
	F3 = 6
	F4 = 7
	mapload()
	player.load()
	P_bullets = 8
	end
end